<template>
  <div>
    <h2>Route aanpassen</h2>
    <div class="bg-white m-3 p-3 border-radius drop-shadow">
      <div class="row justify-content-center">
        <form @submit.prevent="onSubmit" class="col-lg-6">
          <div class="mb-3">
            <label for="name" class="h5 mb-1 required">Naam</label>
            <input
              class="form-control p-2"
              required
              v-model="fields.name"
              type="text"
            />
          </div>
          <div class="row">
            <div class="mb-3 col-6">
              <label for="region" class="h5 mb-1 required">Regio</label>
              <select
                class="form-select"
                v-model="fields.region"
                aria-label="Default select example"
                type="number"
              >
                <option
                  v-for="region in regions"
                  :value="region.id"
                  :key="region.id"
                >
                  {{ region.name }}
                </option>
              </select>
            </div>
          </div>
          <div class="mb-3">
            <div
              class="error-text"
              v-for="(error, index) in this.errors"
              :key="index"
            >
              {{ error }}
            </div>
          </div>
          <button type="submit">Opslaan</button>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  components: {},
  data() {
    return {
      submitting: false,
      fields: {},
      moreInfo: false,
      errors: [],
      hasErrors: false,
      rounds: [],
      location: {
        lon: 0,
        lat: 0,
      },
    };
  },
  props: ["id"],
  created() {
    this.fetchRegions();
    this.fetchRound();
  },
  methods: {
    onSubmit() {
      this.validateFields(this.fields);
      if (!this.hasErrors) {
        this.updateRound();
      }
    },
    async updateRound() {
      const userData = {
        id: this.fields.id,
        name: this.fields.name,
        regionId: this.fields.region,
      };
      await axios
        .put(
          "/api/round",
          userData, // the data to post
          {
            withCredentials: true,
            headers: {
              "Access-Control-Allow-Origin": "*",
              "Content-Type": "application/json",
            },
          }
        )
        .then((response) => {
          console.log(response);
          this.$router.push({
            name: "RoutesDetail",
            params: { id: this.fields.id },
          });
        });
    },
    validateFields(fields) {
      if (fields.region === "" || !fields.region) {
        this.hasErrors = true;
        this.errors[0] = "Geen regio geselecteerd.";
      } else {
        this.hasErrors = false;
        this.errors.splice(0);
      }
    },
    async fetchRegions() {
      try {
        const response = await axios.get("/api/region");
        this.regions = response.data;
      } catch (error) {
        console.error("Failed to fetch rounds:", error);
      }
    },
    fetchRound() {
      axios
        .get("/api/round/" + this.$route.params.id, {
          withCredentials: true,
          headers: {
            "Access-Control-Allow-Origin": "*",
            "Content-Type": "application/json",
          },
        })
        .then((response) => {
          this.fields = response.data;
          this.fields.region = response.data.region.id;
        });
    },
  },
  mounted() {
    this.fetchRegions(); // Fetch the rounds when the component is mounted
  },
  computed: {
    formData() {
      const fd = new FormData();
      Object.keys(this.fields).forEach((key) => {
        fd.append(key, this.fields[key]);
      });
      return fd;
    },
  },
};
</script>

<style lang="scss" scoped>
.error-text {
  color: red;
}

.show:hover {
  cursor: pointer;
}
label.required:after {
  content: " *";
  color: red;
}
#map {
  height: 12rem;
}
</style>
